﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using MongoDB.Driver; //dodala
using MongoDB.Bson; //dodala
using System.Threading; //dodala

namespace Projekt_RNB_AnaMustapic
{
    public class Kupci
    {
        public ObjectId _id { set; get; }
        public string NazivFirme { get; set; }
        public long Oib { get; set; }
        public string Ulica { get; set; }
        public int Kbr { get; set; }
        public int PostaId { get; set; }
        public string Mjesto { get; set; }
        public IEnumerable<string> KupljeniProizvodi { get; set; }
        
    }
    public class Proizvodi
    {
        public ObjectId _id { set; get; }
        public string NazivProizvoda { get; set; }
        public string Vrsta { get; set; }
        public long sifraProizvoda { get; set; }
        public string JedinicaMjere { get; set; }
        public int KolicinaProizvoda { get; set; }
        public double CijenaProizvoda { get; set; }
       
    }
    public class RadnaSnaga
    {
        public ObjectId _id { set; get; }
        public string Ime { get; set; }
        public string Prezime { get; set; }
        public long Oib { get; set; }
        public string Zanimanje { get; set; }
        public double Placa { get; set; }
    }
    class Program
    {
        //KUPCI
        private static IEnumerable<Kupci> GetKupci()
        {
            List<Kupci> lista = new List<Kupci>();
            Kupci k = new Kupci
            {
                NazivFirme = "Kokolo d.o.o",
                Oib = 12345678910,
                Ulica = "Bruna Bušića",
                Kbr = 12,
                PostaId = 21000,
                Mjesto = "Split",
                KupljeniProizvodi = new List<string> {"Lubin", "Orada", "Mušule", "Kamenica"},              
            };
            lista.Add(k);

            k = new Kupci
            {
                NazivFirme = "Koko d.o.o",
                Oib = 12345789642,
                Ulica = "Iva Vojnovica",
                Kbr = 23,
                PostaId = 20000,
                Mjesto = "Dubrovnik",
                KupljeniProizvodi = new List<string> { "Lubin", "Orada", "Kamenica" },
            };
            lista.Add(k);

            k = new Kupci
            {
                NazivFirme = "Ostreum j.d.o.o",
                Oib = 09321548793,
                Ulica = "Blaževo",
                Kbr = 14,
                PostaId = 20246,
                Mjesto = "Janjina",
                KupljeniProizvodi = new List<string> {"Mušule", "Kamenica" },
            };
            lista.Add(k);

            k = new Kupci
            {
                NazivFirme = "Dido d.o.o",
                Oib = 51254125485,
                Ulica = "Blaževo",
                Kbr = 14,
                PostaId = 20246,
                Mjesto = "Janjina",
                KupljeniProizvodi = new List<string> { "Lubin", "Orada", "Mušule", "Kamenica" },
            };
            lista.Add(k);

            return lista;
        }
        //PROIZVODI
        private static IEnumerable<Proizvodi> GetProizvodi()
        {
            List<Proizvodi> lista2 = new List<Proizvodi>();
            Proizvodi p = new Proizvodi
            {
                NazivProizvoda="Lubin",
                Vrsta="Riba",
                sifraProizvoda=0001,
                JedinicaMjere="kg",
                KolicinaProizvoda=100,
                CijenaProizvoda=70,
            };
            lista2.Add(p);

            p = new Proizvodi
            {
                NazivProizvoda = "Orada",
                Vrsta="Riba",
                sifraProizvoda = 0002,
                JedinicaMjere = "kg",
                KolicinaProizvoda = 100,
                CijenaProizvoda = 75,
            };
            lista2.Add(p);

            p = new Proizvodi
            {
                NazivProizvoda = "Dagnje",
                Vrsta="Školjka",
                sifraProizvoda = 0003,
                JedinicaMjere = "kg",
                KolicinaProizvoda = 10000,
                CijenaProizvoda = 10,
            };
            lista2.Add(p);

            p = new Proizvodi
            {
                NazivProizvoda = "Kamenica",
                Vrsta = "Školjka",
                sifraProizvoda = 0004,
                JedinicaMjere = "kom",
                KolicinaProizvoda = 10000,
                CijenaProizvoda =5,
            };
            lista2.Add(p);

            return lista2;
        }

        //RADNA SNAGA
        private static IEnumerable<RadnaSnaga> GetRadnaSnaga()
        {
            List<RadnaSnaga> lista3 = new List<RadnaSnaga>();
            RadnaSnaga rs = new RadnaSnaga
            {
               Ime="Ivica",
               Prezime="Ivić",
               Oib=03125451235,
               Zanimanje="Ribar",
               Placa=6000,
            };
            lista3.Add(rs);
            
            rs = new RadnaSnaga
            {
                Ime = "Ana",
                Prezime = "Anić",
                Oib = 21542125487,
                Zanimanje = "Ribarica",
                Placa = 5000,
            };
            lista3.Add(rs);

            return lista3;
        }
            static void Main(string[] args)
        {
            //povezivanje na bazu
            MongoClient klijent = new MongoClient("mongodb://localhost:27017");
            var database = klijent.GetDatabase("RIBOGOJILIŠTE");

            //Kolekcija Kupci
            IMongoCollection<Kupci> kolekcija1 = database.GetCollection<Kupci>("Kupci");
            //IEnumerable<Kupci> newKupci = GetKupci();
           //kolekcija1.InsertMany(newKupci);

            //Kolekcija Proizvodi
            IMongoCollection<Proizvodi> kolekcija2 = database.GetCollection<Proizvodi>("Proizvodi");
            //IEnumerable<Proizvodi> newProizvodi = GetProizvodi();
            //kolekcija2.InsertMany(newProizvodi);

            //Kolekcija Radna Snaga
            IMongoCollection<RadnaSnaga> kolekcija3 = database.GetCollection<RadnaSnaga>("RadnaSnaga");
            //IEnumerable<RadnaSnaga> newRadnaSnaga = GetRadnaSnaga();
            // kolekcija3.InsertMany(newRadnaSnaga);

            //--------------------------------------------------------------------------------------------------
            //Update 1-->Mijenjam Naziv firme Kupca
            var update = Builders<Kupci>.Update
                .Set(x => x.NazivFirme, "ĐIDO d.o.o")
                .Set(x => x.Oib, 12542157892);
            var rezultat = kolekcija1.FindOneAndUpdate<Kupci>(x =>x.NazivFirme =="Dido d.o.o",update);

            //Update 2-->Mijenjam naziv proizvoda
            var update1 = Builders<Proizvodi>.Update
               .Set(x => x.NazivProizvoda, "Mušula")
               .Set(x => x.CijenaProizvoda, 12);
            var rezultat1 = kolekcija2.FindOneAndUpdate<Proizvodi>(x => x.NazivProizvoda == "Dagnje", update1);
            
            //Update 3-->Mijenjam ime radnika
            var update2 = Builders<RadnaSnaga>.Update
                .Set(x => x.Ime, "Luka")
                .Set(x => x.Prezime, "Banović");
            var rezultat2 = kolekcija3.FindOneAndUpdate<RadnaSnaga>(x=>x.Ime=="Ivica",update2);
            //----------------------------------------------------------------------------------------------------------------

            // LINQ -ispis filtera za Kolekciju Kupci
            kolekcija1.Find(x => x.NazivFirme == "Ostreum j.d.o.o" || x.Mjesto=="Janjina")
                .ForEachAsync<Kupci>(x => Console.WriteLine("Pronašao sam:{0} {1} {2}", x.NazivFirme, x.Oib, x.Mjesto));
            Thread.Sleep(1000);

            // LINQ -ispis filtera za Kolekciju Proizvodi
            kolekcija2.Find(x => x.Vrsta == "Riba" || x.NazivProizvoda == "Lubin")
                .ForEachAsync<Proizvodi>(x => Console.WriteLine("Pronašao sam:{0} {1} {2}", x.sifraProizvoda, x.NazivProizvoda, x.CijenaProizvoda));
            Thread.Sleep(1000);

            // LINQ -ispis filtera za Kolekciju Radna Snaga
            kolekcija3.Find(x => x.Ime == "Ana" || x.Zanimanje == "Ribarica")
                .ForEachAsync<RadnaSnaga>(x => Console.WriteLine("Pronašao sam:{0} {1} {2}", x.Ime, x.Prezime, x.Zanimanje));
            Thread.Sleep(1000);

            //------------------------------------------------------------------------------------------------------------------
            //ISPIS KUPACA IZ BAZE
            Console.Write("POPIS SVIH KUPACA:\n");
            IEnumerable<Kupci> list = GetKupci();
            foreach (var item in list)
            {
                Console.WriteLine("Naziv firme:{0}\nOib:{1}\nMjesto:{2}", item.NazivFirme, item.Oib, item.Mjesto);
            }
            Thread.Sleep(1000);

            //ISPIS PROIZVODA IZ BAZE
            Console.Write("\nPOPIS SVIH PROIZVODA:\n");
            IEnumerable<Proizvodi> list1 = GetProizvodi();
            foreach (var item in list1)
            {
                Console.WriteLine("Sifra proizvoda:{0}\nNaziv proizvoda:{1}\nCijena:{2}", item.sifraProizvoda, item.NazivProizvoda, item.CijenaProizvoda);
            }
            Thread.Sleep(1000);
            //ISPIS RADNE SNAGE IZ BAZE
            Console.Write("\nPOPIS RADNE SNAGE:\n");
            IEnumerable<RadnaSnaga> list2 = GetRadnaSnaga();
            foreach (var item in list2)
            {
                Console.WriteLine("Ime:{0}\nPrezime:{1}\nPlaća:{2}", item.Ime, item.Prezime, item.Placa);
            }
            Thread.Sleep(1000);

            //BRISANJE
            //var brisanje = kolekcija1.DeleteOne<Kupci>(x => x.Mjesto == "Split");

            Console.ReadLine();
        }
    }
}
